000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID.    THE-TOWER-OF-HANOI.
000300*
000400 ENVIRONMENT DIVISION.
000500*
000600 DATA DIVISION.
000700*
000800 WORKING-STORAGE SECTION.
000900 01  STACK-AREA.
001000     02  ESP              PIC S9(3) COMP.
001100     02  STACK-FRAME      OCCURS 1024.
001200         03  STACK-DISKS  PIC 9(1).
001300         03  STACK-FROM   PIC X(1).
001400         03  STACK-TO     PIC X(1).
001500         03  STACK-VIA    PIC X(1).
001600         03  STACK-ACT    PIC 9(1).
001700*
001800 01  CURRENT-FRAME.
001900     02  CURRENT-DISKS    PIC 9(1)  VALUE 3.
002000     02  CURRENT-FROM     PIC X(1)  VALUE "A".
002100     02  CURRENT-TO       PIC X(1)  VALUE "B".
002200     02  CURRENT-VIA      PIC X(1)  VALUE "C".
002300     02  CURRENT-ACT      PIC 9(1)  VALUE 0.
002400*
002500 01  TEMP-FRAME.
002600     02  TEMP-DISKS       PIC 9(1).
002700     02  TEMP-FROM        PIC X(1).
002800     02  TEMP-TO          PIC X(1).
002900     02  TEMP-VIA         PIC X(1).
003000     02  TEMP-ACT         PIC 9(1).
003100*
003200 PROCEDURE  DIVISION.
003300 HANOI-START.
003400*    ディスクの数を入力（改行コードも必要）
003500     ACCEPT CURRENT-DISKS.
003600*
003700     MOVE  1                  TO  ESP.
003800     MOVE  CURRENT-FRAME      TO  STACK-FRAME (ESP).
003900     PERFORM  DO-HANOI
004000         UNTIL  ESP = ZERO.
004100     STOP RUN.
004200*
004300 DO-HANOI.
004400     MOVE  STACK-FRAME (ESP)  TO  CURRENT-FRAME.
004500     SUBTRACT  1            FROM  ESP.
004600     IF CURRENT-ACT = 0
004700         IF CURRENT-DISKS = 1
004800             DISPLAY  CURRENT-FROM " -> " CURRENT-TO
004900         ELSE
005000             MOVE  CURRENT-FRAME  TO  TEMP-FRAME
005100             MOVE  1              TO  TEMP-ACT
005200             ADD   1              TO  ESP
005300             MOVE  TEMP-FRAME     TO  STACK-FRAME (ESP)
005400             MOVE  CURRENT-DISKS  TO  TEMP-DISKS
005500             MOVE  CURRENT-FROM   TO  TEMP-FROM
005600             MOVE  CURRENT-TO     TO  TEMP-VIA
005700             MOVE  CURRENT-VIA    TO  TEMP-TO
005800             SUBTRACT  1        FROM  TEMP-DISKS
005900             MOVE  0              TO  TEMP-ACT
006000             ADD   1              TO  ESP
006100             MOVE TEMP-FRAME      TO  STACK-FRAME (ESP)
006200         END-IF
006300     ELSE
006400         DISPLAY CURRENT-FROM " -> " CURRENT-TO
006500         MOVE  CURRENT-DISKS  TO  TEMP-DISKS
006600         MOVE  CURRENT-FROM   TO  TEMP-VIA
006700         MOVE  CURRENT-VIA    TO  TEMP-FROM
006800         MOVE  CURRENT-TO     TO  TEMP-TO
006900         MOVE  0              TO  TEMP-ACT
007000         SUBTRACT  1        FROM  TEMP-DISKS
007100         ADD   1              TO  ESP
007200         MOVE TEMP-FRAME      TO  STACK-FRAME (ESP)
007300     END-IF.
